import com.alibaba.fastjson.JSON;
import model.*;
import java.io.*;
import java.net.URLEncoder;

public class Client {
    private static final String BASE_URL = "https://jobapi.tasq.com.au/api/";
    private static final String CREATE_CLIENT = "https://jobapi.tasq.com.au/api/Job/CreateClient";
    private static final String EDIT_CLIENT = "https://jobapi.tasq.com.au/api/Job/EditClient";
    private static final String DELETE_CLIENT = "https://jobapi.tasq.com.au/api/Job/DeleteClient";
    private static final String IMPORT_CLIENT = "https://jobapi.tasq.com.au/api/Job/ImportClient";
   //public static final String GET_CLIENT = "https://jobapi.tasq.com.au/api/Job/GetClientList?Jsonlogin={\"LoginName\":\"testapi@tasq.com.au\",\"ClientIP\":null,\"Password\":\"test123.\",\"MobileDeviceToken\":null,\"WebApiTOKEN\":\"b3b777b0-c7af-458d-be64-b3d6d760177f\"}&IsLoadInactive=true";
    public static void main(String[] args) {
        LoginDetail loginDetail = new LoginDetail();
        String loginStr = "";
        String jsonStr = JSON.toJSON(loginDetail).toString();
        try {
            loginStr = URLEncoder.encode(jsonStr, "UTF-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        GetClientList(BASE_URL + "Job/GetClientList?Jsonlogin=" + loginStr + "&IsLoadInactive=true");

        //Create Client
        createClient();
    }

    private static void createClient(){
        LoginDetail loginDetail = new LoginDetail();
        ClientResult clientResult = new ClientResult();
        clientResult.setCompanyValidateInfo(loginDetail);
        clientResult.setClient(setClientData());
        clientResult.setNeedValidate(false);
        String createClientData = JSON.toJSONString(clientResult);
        CreateClient(createClientData);
    }

    private static ClientData setClientData(){
        ClientData clientData = new ClientData();
        clientData.setClientName("testClientName11");
        clientData.setJobContactFirstName("test11");
        clientData.setBillingContactFirstName("name11");
        clientData.setJobCountry("China");
        return clientData;
    }

    private void deleteClient(){
        LoginDetail loginDetail = new LoginDetail();
        ClientResult clientResult = new ClientResult();
        clientResult.setCompanyValidateInfo(loginDetail);
        clientResult.setID("43585a03-8036-4d97-a941-840ebf756078");
        clientResult.setNeedValidate(false);
        String createClientData = JSON.toJSON(clientResult).toString();
        DeleteClient(createClientData);
    }

    private static void CreateClient(String json) {
        HttpManager.doPost(json, CREATE_CLIENT);
    }

    private static void EditClient(String json) {
        HttpManager.doPost(json, EDIT_CLIENT);
    }

    private static void DeleteClient(String json) {
        HttpManager.doPost(json, DELETE_CLIENT);
    }

    private static void ImportClient(String json) {
        HttpManager.doPost(json, IMPORT_CLIENT);
    }

    private static void GetClientList(String path) {
       HttpManager.doGet(path);
    }
}
